
#include <iostream>
#include "conio.h"

using namespace std;

class Reale {

   float r;

   public:

   // definisce l'operatore assegnazione per l'oggetto numero reale
   void operator= (float vr)
   {
       r = vr;
   }   

   // definisce l'operatore somma per l'oggetto numero reale
   Reale operator+ (Reale ogg_re)
   {
        Reale ris;
         
        ris.r = r + ogg_re.r;

        return(ris);
   }

   // definisce l'operatore moltiplicazione per l'oggetto numero reale
   Reale operator* (Reale ogg_re)
   {
       Reale ris;
       
       ris.r = r * ogg_re.r;

        return(ris);       
   }

   // definisce l'operatore inversione di segno per l'oggetto numero reale
   Reale operator- (void)
   {
     Reale opp;

      opp.r = - (*this).r;
      return(opp);
   }

  // definisce l'operatore sottrazione per l'oggetto numero reale
   Reale operator- (Reale ogg_re)
   {
      Reale ris;

      ris = (*this) + (- ogg_re);   // operazione su reali che sfrutta l'op. +
      return(ris);                  // definito in precedenza
   }

   float dai_valore()
   {
       return(r);
   }
};


void main()
{
   Reale r1, r2, rr;

   r1 = 2.34;
   r2 = 3.21;

   cout << r1.dai_valore() << endl << r2.dai_valore() << endl;

   rr = r2 + r1;   // operazione di somma di due reali
                   // tramite l'operator overloading dell' operatore +

   cout << rr.dai_valore() << endl;

   r2 = -r1;

   cout << r2.dai_valore() << endl;

   r2 = 12.223;
   r1 = 2.211;
   r2 = r2 - r1;

   cout << r2.dai_valore() << endl;   

   getch();
}


